var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.ts
var src_exports = {};
__export(src_exports, {
  default: () => src_default,
  validateQuery: () => validateQuery
});
module.exports = __toCommonJS(src_exports);

// src/allowed.ts
var ALLOWED_OPERATORS = [
  // Comparison Operators
  "$eq",
  "$gt",
  "$gte",
  "$lt",
  "$lte",
  "$ne",
  "$in",
  "$nin",
  // Logical Operators
  "$and",
  "$or",
  "$not",
  "$nor",
  // Element Operators
  "$exists",
  "$type",
  // Array Operators
  "$all",
  "$elemMatch",
  "$size",
  // Evaluation Operators
  "$expr",
  "$jsonSchema",
  // Geospatial Operators
  "$geoWithin",
  "$geoIntersects",
  // Text Search Operators
  "$text",
  // Bitwise Operators
  "$bitsAllSet",
  "$bitsAnySet",
  "$bitsAllClear"
];

// src/index.ts
function validateField(key, allowedOperators) {
  if (key.startsWith("$") && !allowedOperators.includes(key)) {
    return false;
  }
  return true;
}
function traverse(obj, maxDepth = 0, path = "", currentDepth = 0, invalidFields = []) {
  for (const key in obj) {
    if (Object.prototype.hasOwnProperty.call(obj, key)) {
      const value = obj[key];
      const fullPath = path ? `${path}.${key}` : key;
      if (typeof value === "object" && value !== null) {
        if (
          // If 0 it's up to infinity
          maxDepth === 0 || currentDepth < maxDepth
        ) {
          traverse(value, maxDepth, fullPath, currentDepth + 1, invalidFields);
        }
      } else {
        if (!validateField(key, ALLOWED_OPERATORS)) {
          invalidFields.push(fullPath);
        }
      }
    }
  }
  return {
    isValidQuery: invalidFields.length === 0,
    invalidFields
  };
}
function validateQuery(obj, maxDepth = 0) {
  return traverse(obj, maxDepth);
}
var src_default = validateQuery;
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  validateQuery
});
